/*
 * Choeps Next Generation GUI
 * 
 * Brent Priddy <toopriddy@mailcity.com>
 *
 * Copyright(C) 1999, Adtran, Inc.
 * 
 * Distributed under the terms of the GNU General Public License (GPL) Version
 *
 * shim between gNet and cheops
 *
 */

#ifndef GUI_DNS_H
#define GUI_DNS_H

#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <adns.h>

typedef void (*dns_timeout_cb)(char *ip, char *hostname, void *data);
typedef void (*dns_answer_cb)(char *ip, char *hostname, void *data);

typedef struct _dns_query {
	struct _dns_query 	*next;
	char 			*hostname;
	char 			*ip;
	struct sockaddr_in	saddr;
	dns_timeout_cb 	timeout_cb;
	dns_answer_cb 		answer_cb;
	unsigned char 		flags;
	void 			*data;
	adns_query 		qu;
} dns_query;

#define DNS_QUERY_FLAGS_NAME		1
#define DNS_QUERY_FLAGS_REVERSE	2

/*
 * Should be in network format
 */
void dns_name_lookup( char *hostname, dns_answer_cb answer_cb, dns_timeout_cb timeout_cb, void *data);
void dns_reverse_lookup( char *ip, dns_answer_cb answer_cb, dns_timeout_cb timeout_cb, void *data);


#endif /* GUI_DNS_H */
