/*
 * Cheops Next Generation
 * 
 * Brent Priddy <toopriddy@mailcity.com>
 *
 * Copyright(C) 1999, Adtran, Inc.
 * 
 * Distributed under the terms of the GNU General Public License (GPL) Version 2
 *
 * Scheduler Routines (front end for gtk)
 *
 */

#include <gtk/gtk.h>
#include "gui-sched.h"

/* 
 * Schedule an event to take place at some point in the future.  callback 
 * will be called with data as the argument, when milliseconds into the
 * future (approximately)
 */
int cheops_sched_add(int when, cheops_sched_cb callback, void *data)
{ 
	return(gtk_timeout_add(when,callback,data));
}

/*
 * Remove this event from being run.  A procedure should not remove its
 * own event, but return 0 instead.
 */
int cheops_sched_del(int id)
{ 
	gtk_timeout_remove(id);
	return(1);
}

