/*
 * Cheops Next Generation
 * 
 * Mark Spencer <markster@marko.net>
 *
 * Copyright(C) 1999, Adtran, Inc.
 * 
 * Distributed under the terms of the GNU General Public License (GPL) Version 2
 *
 * Test Scheduler Routines
 *
 */

#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include "cheops.h"
#include "io.h"
#include "sched.h"

int hello(int *id, int fd, short events, void *data)
{
	char buf[256];
	int res;
	fprintf(stderr, "IO %d called with data '%s'\n", *id, (char *)data);
	res = read(fd, buf, sizeof(buf));
	if (res >= 0) {
		buf[res]='\0';
		fprintf(stderr, "Read: %s", buf);
	} else {
		fprintf(stderr, "Read bad read!\n");
	}
	return 1;
}

int hello2(void *blah)
{
	char *b = blah;
	fprintf(stderr, "%s:(repeat)!\n", b);
	return 1;
}

int main(int argc, char *argv[])
{
	int *id;
	id = cheops_io_add(0, CHEOPS_IO_CB(hello), POLLIN, "Hello World!");
	cheops_sched_add(1000, hello2, "blah");
	cheops_io_dump();
	fprintf(stdout,"Scheduled event %d\n", *id);
	cheops_main();
	return 0;
}
